package com.api.weavercsd.byzl.ncc.action;

package ..deTemp.1729846429020;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.conn.RecordSet;
import weaver.file.ImageFileManager;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

public class NCCApprovalEditAction implements Action {
  private static final Logger logger = LoggerFactory.getLogger(com.api.weavercsd.byzl.ncc.action.NCCApprovalEditAction.class);
  
  private static final String BOUNDARY = "----WebKitFormBoundary7MA4YWxkTrZu0gW";
  
  private static final String LINE_END = "\r\n";
  
  private static final String TWO_HYPHENS = "--";
  
  private static final String CONTENT_DISPOSITION_FORM_DATA = "Content-Disposition: form-data; name=\"";
  
  private static final String CONTENT_DISPOSITION_FORM_DATA_FILE = "Content-Disposition: form-data; name=\"file\"; filename=\"";
  
  public String execute(RequestInfo requestInfo) {
    String charset = "UTF-8";
    String mainId = "";
    String approvalId = "";
    String appDate = "";
    String appUserId = "";
    String leaderUserId = "";
    String leaderWorkcode = "";
    String appWorkcode = "";
    String appDeptId = "";
    String appDeptName = "";
    String projectNameWb = "";
    String projectNameId = "";
    String applyPurpose = "";
    String appReason = "";
    String docId = "";
    String jdcode = "";
    String jdName = "";
    String formResult = "";
    String pdfResult = "";
    String result = "";
    String requestId = Util.null2String(requestInfo.getRequestid());
    logger.info(getClass().getName() + "requestId===>{}", requestId);
    String nodeId = Util.null2String(Integer.valueOf(requestInfo.getRequestManager().getNodeid()));
    logger.info(getClass().getName() + "nodeId===>{}", nodeId);
    try {
      RecordSet mainFromRs = new RecordSet();
      String mainSql = "select h1.id,h1.requestid,h1.ccsqdx,h1.sqrq,h1.ccldr,h1.sqr,h1.sqbm,h1.cclx,h1.xmmcwb,h1.xmmc,h1.xmbh,h1.ccsy,h1.pdf,h2.bh from formtable_main_196 h1 join uf_ccsqjmbzxb h2 on h1.ccsqdx = h2.id where h1.requestid = ? ";
      mainFromRs.executeQuery(mainSql, new Object[] { requestId });
      logger.info(getClass().getName() + "查询语句===>{}", mainSql);
      RecordSet workcodeRs = new RecordSet();
      RecordSet leaderWorkcodeRs = new RecordSet();
      String workcodeSql = "select id,lastname,workcode from hrmresource where id  =  ? ";
      RecordSet dept2Rs = new RecordSet();
      String lastNameSql2 = "select id,departmentname from HrmDepartment where id =  ? ";
      if (mainFromRs.next()) {
        mainId = mainFromRs.getString("id");
        docId = mainFromRs.getString("pdf");
        approvalId = mainFromRs.getString("bh");
        appDate = mainFromRs.getString("sqrq");
        appUserId = mainFromRs.getString("sqr");
        leaderUserId = mainFromRs.getString("ccldr");
        logger.info("leaderUserId======>{}", leaderUserId);
        if (appUserId != null && !appUserId.isEmpty()) {
          workcodeRs.executeQuery(workcodeSql, new Object[] { appUserId });
          if (workcodeRs.next())
            appWorkcode = workcodeRs.getString("workcode"); 
        } 
        if (leaderUserId != null && !leaderUserId.isEmpty()) {
          leaderWorkcodeRs.executeQuery(workcodeSql, new Object[] { leaderUserId });
          if (leaderWorkcodeRs.next())
            leaderWorkcode = leaderWorkcodeRs.getString("workcode"); 
        } else {
          logger.info("leaderUserId为空");
        } 
        appDeptId = mainFromRs.getString("sqbm");
        if (appDeptId != null && !appDeptId.isEmpty()) {
          dept2Rs.executeQuery(lastNameSql2, new Object[] { appDeptId });
          if (dept2Rs.next())
            appDeptName = dept2Rs.getString("departmentname"); 
        } 
        projectNameWb = mainFromRs.getString("xmmcwb");
        projectNameId = mainFromRs.getString("xmmc");
        applyPurpose = mainFromRs.getString("cclx");
        switch (applyPurpose) {
          case "0":
            applyPurpose = "临时出差";
            break;
          case "1":
            applyPurpose = "项目出差";
            break;
          default:
            applyPurpose = "其它";
            break;
        } 
        appReason = mainFromRs.getString("ccsy");
        logger.info("mainId======>{}", mainId);
        logger.info("approvalId======>{}", approvalId);
        logger.info("docId======>{}", docId);
        logger.info("appDate======>{}", appDate);
        logger.info("appUserId======>{}", appUserId);
        logger.info("appWorkcode======>{}", appWorkcode);
        logger.info("leaderWorkcode======>{}", leaderWorkcode);
        logger.info("appDeptName======>{}", appDeptName);
        logger.info("projectNameWb======>{}", projectNameWb);
        logger.info("projectNameId======>{}", projectNameId);
        logger.info("applyPurpose======>{}", applyPurpose);
        logger.info("appReason======>{}", appReason);
      } 
      List<Map<String, String>> dt1List = new ArrayList<>();
      RecordSet dt1FromRs = new RecordSet();
      String dt1Sql = "select mainid,xm,bm,gw,jd,ccksrq,ccjsrq,ts from formtable_main_196_dt1 where mainid = ? ";
      dt1FromRs.executeQuery(dt1Sql, new Object[] { mainId });
      logger.info(getClass().getName() + "查询语句===>{}", dt1Sql);
      RecordSet lastNameRs = new RecordSet();
      RecordSet jobTitleRs = new RecordSet();
      RecordSet deptRs = new RecordSet();
      String lastNameSql = "select id,lastname from hrmresource where id  =  ? ";
      String jobTitleSql = "select id,jobtitlename from HrmJobTitles where id = ?  ";
      String deptSql = "select id,departmentname from HrmDepartment where id = ? ";
      while (dt1FromRs.next()) {
        Map<String, String> dt1Map = new HashMap<>();
        String ccrId = dt1FromRs.getString("xm");
        String ccrbmId = dt1FromRs.getString("bm");
        String ccrgwId = dt1FromRs.getString("gw");
        if (ccrId != null && !ccrId.isEmpty()) {
          lastNameRs.executeQuery(lastNameSql, new Object[] { ccrId });
          if (lastNameRs.next())
            dt1Map.put("ccr", lastNameRs.getString("lastname")); 
        } 
        if (ccrbmId != null && !ccrbmId.isEmpty()) {
          deptRs.executeQuery(deptSql, new Object[] { ccrbmId });
          if (deptRs.next())
            dt1Map.put("ccrbm", deptRs.getString("departmentname")); 
        } 
        if (ccrgwId != null && !ccrgwId.isEmpty()) {
          jobTitleRs.executeQuery(jobTitleSql, new Object[] { ccrgwId });
          if (jobTitleRs.next())
            dt1Map.put("ccrgw", jobTitleRs.getString("jobtitlename")); 
        } 
        jdcode = dt1FromRs.getString("jd");
        logger.info("jdcode======>{}", jdcode);
        switch (jdcode) {
          case "0":
            jdName = "预沟通前";
            break;
          case "1":
            jdName = "预沟通后立项前";
            break;
          case "2":
            jdName = "立项后租委会前";
            break;
          case "3":
            jdName = "租委会后签合同前";
            break;
          case "4":
            jdName = "签合同后放款前";
            break;
          case "5":
            jdName = "放款后";
            break;
          default:
            jdName = "其它";
            break;
        } 
        dt1Map.put("oabid", "13131313132");
        dt1Map.put("jdcode", jdcode);
        dt1Map.put("jdName", jdName);
        dt1Map.put("beginrq", dt1FromRs.getString("ccksrq"));
        dt1Map.put("endrq", dt1FromRs.getString("ccjsrq"));
        dt1Map.put("days", dt1FromRs.getString("ts"));
        dt1List.add(dt1Map);
        logger.info("dt1List======>{}", dt1List);
      } 
      logger.info("dt1List======>{}", dt1List);
      Map<String, Object> dataMap = new HashMap<>();
      dataMap.put("oaid", approvalId);
      dataMap.put("sqdcode", approvalId);
      dataMap.put("sqrq", appDate);
      dataMap.put("sqr", appWorkcode);
      dataMap.put("sqbm", appDeptName);
      dataMap.put("cclx", applyPurpose);
      dataMap.put("ldr", leaderWorkcode);
      dataMap.put("ccsy", appReason);
      dataMap.put("bgxtbh", "");
      dataMap.put("zlxtxmbh", "");
      dataMap.put("details", dt1List);
      logger.info("dataMap======>{}", dataMap);
      RecordSet reqUrlRs = new RecordSet();
      String sqlFrom = "select devvalue from uf_xtpzb where devkey = 'app_form_edit' and model='ecology_ncc_app'";
      reqUrlRs.executeQuery(sqlFrom, new Object[0]);
      logger.info(getClass().getName() + "查询语句===>{}", sqlFrom);
      String addFromUrl = "";
      if (reqUrlRs.next()) {
        addFromUrl = reqUrlRs.getString("devvalue");
        logger.info("opeFromUrl======>{}", addFromUrl);
      } 
      if (addFromUrl.equals(""))
        logger.info("opeFromUrl"); 
      Gson gson = new Gson();
      String json = gson.toJson(dataMap);
      HttpClient httpClient = new HttpClient();
      httpClient.getHttpConnectionManager().getParams().setConnectionTimeout(5000);
      PostMethod postMethod = new PostMethod(addFromUrl);
      postMethod.getParams().setParameter("http.socket.timeout", Integer.valueOf(5000));
      postMethod.getParams().setParameter("http.method.retry-handler", new DefaultHttpMethodRetryHandler());
      try {
        postMethod.setRequestEntity((RequestEntity)new StringRequestEntity(json, "application/json", charset));
      } catch (Exception e) {
        e.printStackTrace();
        return "0";
      } 
      try {
        int statusCode = httpClient.executeMethod((HttpMethod)postMethod);
        logger.info("statusCode====>{}", Integer.valueOf(statusCode));
        if (statusCode != 200) {
          logger.info("请求出错：" + postMethod.getStatusLine());
          return "0";
        } 
        byte[] responseBody = postMethod.getResponseBody();
        String response = new String(responseBody, charset);
        logger.info("接口返回数据为：" + response);
        JSONObject jsonObjectOut = new JSONObject(response);
        logger.info(getClass().getName() + "-----------------------处理json数据-----------------------------");
        logger.info(getClass().getName() + "接口响应返回码===>{}" + jsonObjectOut.get("resultCode"));
        formResult = jsonObjectOut.get("processSucessful").toString();
        if (jsonObjectOut.getString("resultCode").equals("1")) {
          logger.info(getClass().getName() + "接口响应返回码===>{}" + jsonObjectOut.get("content"));
          String jsonResponse = jsonObjectOut.get("content").toString();
          JsonObject jsonObject = JsonParser.parseString(jsonResponse).getAsJsonObject();
          String billid = jsonObject.get("billid").getAsString();
          logger.info("billid======>{}", billid);
          if (docId != null) {
            RecordSet pdfRs = new RecordSet();
            String queryImageIdSql = "select imagefilename,imagefileid from docimagefile where docid = ? ";
            pdfRs.executeQuery(queryImageIdSql, new Object[] { docId });
            String imagefileid = "";
            String imagefilename = "";
            if (pdfRs.next()) {
              imagefilename = pdfRs.getString("imagefilename");
              imagefileid = pdfRs.getString("imagefileid");
              logger.info("imagefileid======>{}", imagefileid);
              logger.info("imagefilename======>{}", imagefilename);
            } 
            ImageFileManager imageFileManager = new ImageFileManager();
            imageFileManager.getImageFileInfoById(Integer.parseInt(imagefileid));
            logger.info(getClass().getName() + "获取pdf文件流:imageFileManager===>{}", imageFileManager);
            RecordSet pdfUrlRs = new RecordSet();
            String pdfSql = "select devvalue from uf_xtpzb where devkey = 'app_pdf_add' and model='ecology_ncc_app'";
            pdfUrlRs.executeQuery(pdfSql, new Object[0]);
            logger.info(getClass().getName() + "查询语句===>{}", pdfSql);
            String addPdfUrl = "";
            if (pdfUrlRs.next()) {
              addPdfUrl = pdfUrlRs.getString("devvalue");
              logger.info("addPdfUrl======>{}", addPdfUrl);
            } 
            if (addFromUrl.equals(""))
              logger.info("opeFromUrl"); 
            try (InputStream inputStream = imageFileManager.getInputStream()) {
              URL obj = new URL(addPdfUrl);
              HttpURLConnection con = (HttpURLConnection)obj.openConnection();
              con.setRequestMethod("POST");
              con.setRequestProperty("Connection", "Keep-Alive");
              con.setRequestProperty("Content-Type", "multipart/form-data;boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW");
              con.setDoOutput(true);
              con.setDoInput(true);
              OutputStream outputStream = con.getOutputStream();
              writeFormData(outputStream, "billid", billid);
              String imagefilenameS = sanitizeFileName(imagefilename);
              logger.info("imagefilenameS======>{}", imagefilenameS);
              writeFilePart(outputStream, imagefilename, inputStream);
              outputStream.write("--".getBytes());
              outputStream.write("----WebKitFormBoundary7MA4YWxkTrZu0gW".getBytes());
              outputStream.write("--".getBytes());
              outputStream.write("\r\n".getBytes());
              outputStream.flush();
              int responseCode = con.getResponseCode();
              logger.info("uploadAttachment======>Response Code : " + responseCode);
              BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream(), "UTF-8"));
              StringBuilder res = new StringBuilder();
              String inputLine;
              while ((inputLine = in.readLine()) != null)
                res.append(inputLine); 
              in.close();
              logger.info(getClass().getName() + "-----------------------处理PDF的json数据-----------------------------");
              ObjectMapper objectMapper = new ObjectMapper();
              Map<String, Object> resUpload = objectMapper.<Map<String, Object>>readValue(res.toString(), (Class)Map.class);
              logger.info("uploadAttachment======>resUpload:{}", resUpload);
              pdfResult = resUpload.get("processSucessful").toString();
              logger.info("pdfResult===>{}", pdfResult);
            } catch (IOException iOException) {}
          } 
          logger.info(getClass().getName() + "处理json数据成功");
        } 
        if (formResult.equals("true") && pdfResult.equals("true")) {
          result = "Y";
        } else {
          result = "N";
        } 
        Date date = new Date();
        SimpleDateFormat formatter1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String formattedDates = formatter1.format(date);
        RecordSet logRs = new RecordSet();
        String logSql = "insert into uf_ncccsqrzb (formmodeid,bdcscs,wjid,cgbs,sj) values (9001,'" + json + "','" + docId + "','" + result + "','" + formattedDates + "' )";
        logger.info(getClass().getName() + "logSql===>" + logSql);
        logRs.executeUpdate(logSql, new Object[0]);
        return "1";
      } catch (HttpException e) {
        System.out.println("请检查输入的 URL!");
        e.printStackTrace();
        return "0";
      } catch (IOException e) {
        System.out.println("发生网络异常!");
        e.printStackTrace();
        return "0";
      } finally {
        postMethod.releaseConnection();
      } 
    } catch (Exception e) {
      throw new RuntimeException(e);
    } 
  }
  
  private static void writeFilePart(OutputStream outputStream, String filename, InputStream fileInput) throws IOException {
    outputStream.write("------WebKitFormBoundary7MA4YWxkTrZu0gW\r\n".getBytes("UTF-8"));
    outputStream.write(("Content-Disposition: form-data; name=\"file\"; filename=\"" + filename + "\"" + "\r\n").getBytes("UTF-8"));
    outputStream.write("Content-Type: application/octet-stream\r\n\r\n".getBytes("UTF-8"));
    byte[] buffer = new byte[1024];
    int bytesRead;
    while ((bytesRead = fileInput.read(buffer)) != -1)
      outputStream.write(buffer, 0, bytesRead); 
    outputStream.write("\r\n".getBytes());
  }
  
  private static void writeFormData(OutputStream outputStream, String key, String value) throws IOException {
    outputStream.write("------WebKitFormBoundary7MA4YWxkTrZu0gW\r\n".getBytes("UTF-8"));
    outputStream.write(("Content-Disposition: form-data; name=\"" + key + "\"" + "\r\n").getBytes("UTF-8"));
    outputStream.write("Content-Type: text/plain; charset=UTF-8\r\n\r\n".getBytes("UTF-8"));
    outputStream.write(value.getBytes("UTF-8"));
    outputStream.write("\r\n".getBytes("UTF-8"));
  }
  
  private static String sanitizeFileName(String filename) {
    return filename.replaceAll("[^a-zA-Z0-9._\\u4e00-\\u9fa5]", "_");
  }
}
